| Version: 3.3.1

Public Member Functions | List of all members
wxCloseEvent Class Reference
Class List by Category » Events

`#include <wx/event.h>`

Inheritance diagram for wxCloseEvent:
[legend]

## Detailed Description

This event class contains information about window and session close events.

The handler function for EVT_CLOSE is called when the user has tried to close a frame or dialog box using the window manager (X) or system menu (Windows). It can also be invoked by the application itself programmatically, for example by calling the wxWindow::Close function.

You should check whether the application is forcing the deletion of the window using wxCloseEvent::CanVeto. If this is false, you must destroy the window using wxWindow::Destroy.

If the return value is true, it is up to you whether you respond by destroying the window.

If you don't destroy the window, you should call wxCloseEvent::Veto to let the calling code know that you did not destroy the window. This allows the wxWindow::Close function to return true or false depending on whether the close instruction was honoured or not.

Example of a wxCloseEvent handler:

void MyFrame::OnClose(wxCloseEvent& event)
{
if ( event.CanVeto() && m_bFileNotSaved )
{
if ( wxMessageBox("The file has not been saved... continue closing?",
"Please confirm",
wxICON_QUESTION | wxYES_NO) != wxYES )
{
event.Veto();
return;
}
}
Destroy(); // you may also do: event.Skip();
// since the default event handler does call Destroy(), too
}
wxCloseEvent
This event class contains information about window and session close events.
Definition: event.h:4751
wxCloseEvent::CanVeto
bool CanVeto() const
Returns true if you can veto a system shutdown or a window close event.
wxICON_QUESTION
#define wxICON_QUESTION
Definition: defs.h:461
wxYES_NO
#define wxYES_NO
Definition: defs.h:447
wxYES
#define wxYES
Definition: defs.h:444
wxMessageBox
int wxMessageBox(const wxString &message, const wxString &caption=wxMessageBoxCaptionStr, int style=wxOK|wxCENTRE, wxWindow *parent=nullptr, int x=wxDefaultCoord, int y=wxDefaultCoord)
Show a general purpose message dialog.

See also `samples/dialogs` for a full example of interrupting closing an application when there are e.g. unsaved files.

The EVT_END_SESSION event is slightly different as it is sent by the system when the user session is ending (e.g. because of log out or shutdown) and so all windows are being forcefully closed. At least under MSW, after the handler for this event is executed the program is simply killed by the system. Because of this, the default handler for this event provided by wxWidgets calls all the usual cleanup code (including wxApp::OnExit()) so that it could still be executed and exit()s the process itself, without waiting for being killed. If this behaviour is for some reason undesirable, make sure that you define a handler for this event in your wxApp-derived class and do not call `event.Skip()` in it, but be aware that the system will still kill your application. Because of this, it is usually better to skip this event and let the default handling take place. Please also note that this handler must not be using any UI functionality (such as modal dialogs asking whether the changes should be saved) as it is not safe to do it any more, but it could, for example, save the program state into a file unconditionally in order to restore it during the next program execution.

## Events using this class

The following event handler macros redirect the events to member function handlers 'func' with prototypes like:

void handlerFuncName(wxCloseEvent& event)

Event macros:

- EVT_CLOSE(func):
  Process a `wxEVT_CLOSE_WINDOW` command event, supplying the member function. This event applies to wxFrame and wxDialog classes.
- EVT_QUERY_END_SESSION(func):
  Process a `wxEVT_QUERY_END_SESSION` session event, supplying the member function. This event can be handled in wxApp-derived class only.
- EVT_END_SESSION(func):
  Process a `wxEVT_END_SESSION` session event, supplying the member function. This event can be handled in wxApp-derived class only.

##

Library: wxCore
Category: Events

See also
  wxWindow::Close, Window Deletion

## Public Member Functions
| wxCloseEvent (wxEventType commandEventType=wxEVT_NULL, int id=0)
| Constructor. More...
bool | CanVeto () const
| Returns true if you can veto a system shutdown or a window close event. More...
bool | GetLoggingOff () const
| Returns true if the user is just logging off or false if the system is shutting down. More...
void | SetCanVeto (bool canVeto)
| Sets the 'can veto' flag. More...
void | SetLoggingOff (bool loggingOff)
| Sets the 'logging off' flag. More...
void | Veto (bool veto=true)
| Call this from your event handler to veto a system shutdown or to signal to the calling application that a window close did not happen. More...
bool | GetVeto () const
| Returns whether the Veto flag was set. More...
Public Member Functions inherited from wxEvent
| wxEvent (int id=0, wxEventType eventType=wxEVT_NULL)
| Constructor. More...
virtual wxEvent * | Clone () const =0
| Returns a copy of the event. More...
wxObject * | GetEventObject () const
| Returns the object (usually a window) associated with the event, if any. More...
wxEventType | GetEventType () const
| Returns the identifier of the given event type, such as `wxEVT_BUTTON`. More...
virtual wxEventCategory | GetEventCategory () const
| Returns a generic category for this event. More...
int | GetId () const
| Returns the identifier associated with this event, such as a button command id. More...
wxObject * | GetEventUserData () const
| Return the user data associated with a dynamically connected event handler. More...
bool | GetSkipped () const
| Returns true if the event handler should be skipped, false otherwise. More...
long | GetTimestamp () const
| Gets the timestamp for the event. More...
bool | IsCommandEvent () const
| Returns true if the event is or is derived from wxCommandEvent else it returns false. More...
void | ResumePropagation (int propagationLevel)
| Sets the propagation level to the given value (for example returned from an earlier call to wxEvent::StopPropagation). More...
void | SetEventObject (wxObject *object)
| Sets the originating object. More...
void | SetEventType (wxEventType type)
| Sets the event type. More...
void | SetId (int id)
| Sets the identifier associated with this event, such as a button command id. More...
void | SetTimestamp (long timeStamp=0)
| Sets the timestamp for the event. More...
bool | ShouldPropagate () const
| Test if this event should be propagated or not, i.e. if the propagation level is currently greater than 0. More...
void | Skip (bool skip=true)
| This method can be used inside an event handler to control whether further event handlers bound to this event will be called after the current one returns. More...
int | StopPropagation ()
| Stop the event from propagating to its parent window. More...
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to nullptr the internal reference data. More...
| wxObject (const wxObject &other)
| Copy ctor. More...
virtual | ~wxObject ()
| Destructor. More...
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar). More...
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object. More...
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class. More...
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj. More...
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone. More...
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer. More...
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data. More...
void | UnShare ()
| This is the same of AllocExclusive() but this method is public. More...
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined. More...
void * | operator new (size_t size, const wxString &filename=nullptr, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined. More...

## Additional Inherited Members
Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object. More...
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it. More...
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data. More...
Protected Attributes inherited from wxEvent
int | m_propagationLevel
| Indicates how many levels the event can propagate. More...
Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data. More...

## Constructor & Destructor Documentation

## ◆ wxCloseEvent()

wxCloseEvent::wxCloseEvent | ( | wxEventType | commandEventType = `wxEVT_NULL`,
|  | int | id = `0`
| ) |  |

Constructor.

## Member Function Documentation

## ◆ CanVeto()

bool wxCloseEvent::CanVeto | ( |  | ) | const

Returns true if you can veto a system shutdown or a window close event.

Vetoing a window close event is not possible if the calling code wishes to force the application to exit, and so this function must be called to check this.

## ◆ GetLoggingOff()

bool wxCloseEvent::GetLoggingOff | ( |  | ) | const

Returns true if the user is just logging off or false if the system is shutting down.

This method can only be called for end session and query end session events, it doesn't make sense for close window event.

## ◆ GetVeto()

bool wxCloseEvent::GetVeto | ( |  | ) | const

Returns whether the Veto flag was set.

## ◆ SetCanVeto()

void wxCloseEvent::SetCanVeto | ( | bool | canVeto | ) |

Sets the 'can veto' flag.

## ◆ SetLoggingOff()

void wxCloseEvent::SetLoggingOff | ( | bool | loggingOff | ) |

Sets the 'logging off' flag.

## ◆ Veto()

void wxCloseEvent::Veto | ( | bool | veto = `true` | ) |

Call this from your event handler to veto a system shutdown or to signal to the calling application that a window close did not happen.

You can only veto a shutdown if CanVeto() returns true.